
// Librerias
//#include "stdafx.h"
#include <vector>
#include <sstream>
#include <iostream>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
//#include <windows.h>
#include <queue>
#include <sys/time.h>

#include "filtroCpp.h"
#include "filtrosCUDA.h"
#include "filtroAsm.h"
#include "filtroSSE.h"
#include <opencv/cv.h>
using namespace std;

#define forn(i,n) for(int i = 0 ; i < (int) (n); i++)
#define forsn(i,s,n) for(int i = (s) ; i < (int) (n); i++)
 
// Variables
int g_slider_position = 0;
CvCapture* capture = NULL;

const unsigned MIN_BOKEH = 1;
const unsigned MAX_BOKEH = 64;
unsigned bokehSize = 3;

unsigned  RED = 150, GREEN = 128,BLUE = 250;

const float ROT_SPEED = 1e-4;
float alpha = 0.0;

// Metodo
void onTrackbarSlide(int pos) {
    cvSetCaptureProperty(capture,CV_CAP_PROP_POS_FRAMES,pos);
}

void filtrosConCuda(IplImage *frame, bool *filtro);
void filtrosConCPU(IplImage *frame, bool *filtro);
void filtrosConAssembler(IplImage *frame, bool *filtro);
void filtrosConSSE(IplImage *frame, bool *filtro);


void parciarParametros(int argc, char *arg[], char video[], bool *camara);

template <typename T>
string to_string(const T x)
{
    ostringstream os; os << x;
    return os.str();
}

// Metodo Principal*/
int main( int argc, char** argv ) {
   
    // Creamos una Ventana , con el nombre de Video
    // Con el Tamao Automatico del Video
   
    bool camara = false;
    char video[25] = "default.avi";
	parciarParametros(argc, argv, video, &camara);
	
	
	cvNamedWindow( "Video", CV_WINDOW_AUTOSIZE );
	if (camara)
		capture = cvCreateCameraCapture(0);
	else
		capture = cvCreateFileCapture(video);
   
    int frames = (int) cvGetCaptureProperty(capture,CV_CAP_PROP_FRAME_COUNT);
   
    if( frames!= 0 ) {
     cvCreateTrackbar("Position","Video",&g_slider_position,frames,onTrackbarSlide);
   
    }
    // Iniciamos el Dispositivo de Captura de Video  ,
    // Declaramos una Variable para poder obtener una imagen del video
    IplImage* frame;
	CvFont font;
	double hScale=1.0;
	double vScale=1.0;
	int    lineWidth=1;
	cvInitFont(&font,CV_FONT_HERSHEY_SIMPLEX|CV_FONT_ITALIC, hScale,vScale,0,lineWidth);
 
	int cantidadDeFrameParaElCalculo = 50;
	queue<int> cola;
	bool terminar = false;
	bool cuda = false;
	bool normal = true;
	bool Assembler = false;
	bool sse = false;
	bool enter = false;
	bool imprimir = false;
    int cantidadFotos = 1;
	int delay = 10;
	bool filtro[16];
	for(int i = 0; i < 16; i++) filtro[i] = false;
	//struct timeval cur, end;
	timeval cur;
	gettimeofday(&cur, NULL);
	
    // Ciclo Infinito para poder Optener Imagenes
	long long promedio = 0;
	long double ultima_estadistica = 0;
	int cant_frame = 0;
	while(!terminar) {
		cant_frame++;
		frame = cvQueryFrame( capture ); // Obtenemos Frame desde el Buffer de Video
		//int seg =  cur.tv_sec;
		int useg = cur.tv_usec;
		gettimeofday(&cur,NULL);
		
		int diff =  ((cur.tv_usec - useg) + 500) / 1000;
		if (diff< 0) diff+= (double)1000;

        alpha += diff * ROT_SPEED;

		promedio+= diff;
		cola.push(diff);
		if ((int)cola.size()>cantidadDeFrameParaElCalculo)
		{
			promedio -= cola.front();
			cola.pop();
		}
		ultima_estadistica = (long double)1e3/((long double)promedio/cola.size());

		if (imprimir)
        {
            ostringstream os;
            os << "out" << cantidadFotos << "-orig.jpg";
            cvSaveImage(os.str().c_str(), frame);
        }

		if( !frame ) break; // Si no Obtenemos Frame , Entonces Finalizamos el Ciclo
      
		//filtros:
		if (cuda)	{
			filtrosConCuda(frame, filtro);		
			cvPutText (frame,"Modo: CUDA",cvPoint(50,50), &font, cvScalar(255,255,255));		
		}
		if (normal){
			filtrosConCPU(frame, filtro);
			cvPutText (frame,"Modo: Normal",cvPoint(50,50), &font, cvScalar(255,255,255));		
		}
		if (Assembler){
			filtrosConAssembler(frame, filtro);
			cvPutText (frame,"Modo: Assembler",cvPoint(50,50), &font, cvScalar(255,255,255));		
		}
		if (sse){
			filtrosConSSE(frame, filtro);
			cvPutText (frame,"Modo: SSE",cvPoint(50,50), &font, cvScalar(255,255,255));		
		}
        if (filtro[13])
        {
            ostringstream os; 
            os << "Bokeh: " << bokehSize;
            string text = os.str();
            cvPutText (frame,text.c_str(),cvPoint(350,50), &font, cvScalar(255,255,255));
        }
            
		string activos = "";
        const string LETRAS = "QWERTY";
		string act2 = "";
        
		forn(i,9)
		{
			if (filtro[i])
				activos = activos + ' ' +(char)(i+'1');
		}
        
        forsn(i,10,15)
		{
			if (filtro[i])
				act2 = act2 + ' ' + LETRAS[i - 10];
		}
        
        
		
		activos = "Filtros Activos:" + activos;
		cvPutText (frame,activos.c_str(),cvPoint(50,80), &font, cvScalar(255,255,255));		
        
        activos = "              " + act2;
		cvPutText (frame,activos.c_str(),cvPoint(50,110), &font, cvScalar(255,255,255));		
        
		string aa = "velocidad: "+ to_string(ultima_estadistica) + " frames/seg";
		cvPutText (frame,aa.c_str(),cvPoint(50,150), &font, cvScalar(255,255,255));
		
		if (imprimir) {
            ostringstream os;
            os << "out" << cantidadFotos << "-filtro.jpg";
            cvSaveImage(os.str().c_str(), frame);
			cantidadFotos++;
			imprimir = false;
		}
			
		
		cvShowImage( "Video", frame ); // Desplegamos la Imagen en Pantalla
	  
	  
	  
		// Esperamos delay milesimas de Segundo , si el usuario presiona alguna Tecla
		char c = cvWaitKey(delay);

        if (toupper(c) == 'O' && bokehSize > MIN_BOKEH)
            bokehSize--;
        if (toupper(c) == 'P' && bokehSize < MAX_BOKEH)
            bokehSize++;

		if (c >= '1' && c <= '9')
			filtro[c-'1'] = !filtro[c-'1'];
            
        if (LETRAS.find(toupper(c)) != string::npos)
            filtro[10+ LETRAS.find(toupper(c))] ^= 1;
            
		if (c == 13 || c == 10)
		{
            
			if (!enter)
				imprimir = true;
			enter = true;
		}
		else enter = false;
		switch (c)
		{
			case  27:
				terminar = true;
				break; // Si se Preciono la Tecla ESC entonces se rompe el Ciclo
			case 99:
				cuda = true;
				normal = false;
				Assembler = false;
				sse= false;
				break;
			case 97:
				cuda = false;
				normal = false;
				Assembler = true;
				sse= false;
				break;
			case 115:
				cuda = false;
				normal = false;
				Assembler = false;
				sse= true;
				break;
			case 110:
				cuda = false;
				normal = true;
				Assembler = false;
				sse= false;
				break;
			case 43:
				delay--;
				if (delay < 2) delay = 2;
				break;
			case 45:
				delay++;
				break;
			default:
				break;
		}
   
    }
	cvReleaseCapture( &capture ); // Liberamos el Buffer de Video
	cvDestroyWindow( "Video" ); // Destruir la Ventana
} // fin del metodo principal
/*
typedef struct _IplImage
{
    int  nSize;
    int  ID;
    int  nChannels;
    int  alphaChannel;
    int  depth;
    char colorModel[4];
    char channelSeq[4];
    int  dataOrder;
    int  origin;
    int  align;
    int  width;
    int  height;
    struct _IplROI *roi;
    struct _IplImage *maskROI;
    void  *imageId;
    struct _IplTileInfo *tileInfo;
    int  imageSize;
    char *imageData;
    int  widthStep;
    int  BorderMode[4];
    int  BorderConst[4];
    char *imageDataOrigin;
}
IplImage;
*/
int cont = 0;

void filtrosConCuda(IplImage *frame, bool *filtro)
{
	cont++;
	if (cont %2){
		return filtrosConCPU(frame, filtro);
	}else{
		return filtrosConAssembler(frame, filtro);
	}
	bool ByN = true;
	if (filtro[0])
		cu_BlackAndWhite(frame);
	else ByN= false;
	if (filtro[1])
		cu_invertir(frame);		
	if (filtro[2] && !filtro[7])	
		cu_fotoBinaria(frame);	
	//else filtroRojo = false;
	if (filtro[3])
		cu_zoom(frame);
	if (filtro[4])
		cu_filtroGauseano(frame, ByN);
	if (filtro[5])
		cu_bordesSimples(frame);
	if (filtro[6])
		cu_bordesSobel(frame);
	if (filtro[7])		
		cu_bordesCanny(frame, ByN, filtro[2]);
	if (filtro[8])
		cu_todasJuntas(frame);
		
    if (filtro[10])
        cu_zoomBillinear(frame);
    if (filtro[11])
        cu_duplicarContraste(frame);
    if (filtro[12])
        cu_colorBalance(frame,RED,GREEN,BLUE);
    
    if (filtro[13])
        cu_bokeh(frame,bokehSize);
    if (filtro[14])
        cu_nearestRot(frame,alpha);
    /*if (filtro[15])
        cu_billinearRot(frame,alpha);
        */
}

void filtrosConCPU(IplImage *frame, bool *filtro)
{
	bool ByN = true;
	if (filtro[0])
		BlackAndWhite(frame);
	else ByN= false;

	if (filtro[1])
		invertir(frame);	
	
	
	if (filtro[2] && !filtro[7])	
		fotoBinaria(frame);
	
	//else filtroRojo = false;
	if (filtro[3])
		zoom(frame);
	if (filtro[4])
		filtroGauseano(frame, ByN);
	if (filtro[5])
		bordesSimples(frame);
	if (filtro[6])
		bordesSobel(frame);
	if (filtro[7])		
		bordesCanny(frame, ByN, filtro[2]);
	if (filtro[8])
		todasJuntas(frame);
        
    if (filtro[10])
        zoomBillinear(frame);
    if (filtro[11])
        duplicarContraste(frame);
    if (filtro[12])
        colorBalance(frame,RED,GREEN,BLUE);
    
    if (filtro[13])
        bokeh(frame,bokehSize);
    if (filtro[14])
        nearestRot(frame,alpha);
    /*if (filtro[15])
        billinearRot(frame,alpha);*/
        
}
void filtrosConAssembler(IplImage *frame, bool *filtro)
{
	bool ByN = true;
	if (filtro[0])
		asm_BlackAndWhite(frame);
	else ByN= false;
	if (filtro[1])
		asm_invertir(frame);		
	if (filtro[2] && !filtro[7])	
		asm_fotoBinaria(frame);	
	//else filtroRojo = false;
	if (filtro[3])
		asm_zoom(frame);
	if (filtro[4])
		asm_filtroGauseano(frame, ByN);
	if (filtro[5])
		asm_bordesSimples(frame);
	if (filtro[6])
		asm_bordesSobel(frame);
	if (filtro[7])		
		asm_bordesCanny(frame, ByN, filtro[2]);
	if (filtro[8])
		asm_todasJuntas(frame);
    
    if (filtro[10])
        asm_zoomBillinear(frame);

    if (filtro[11])
        asm_duplicarContraste(frame);
        
    if (filtro[12])
        asm_colorBalance(frame,RED,GREEN,BLUE);

    if (filtro[13])
        asm_bokeh(frame,bokehSize);
    
    if (filtro[14])
        asm_nearestRot(frame,alpha);
    /*
    if (filtro[15])
        asm_billinearRot(frame,alpha);
        */

}
void filtrosConSSE(IplImage *frame, bool *filtro)
{
	bool ByN = true;
	if (filtro[0])
		sse_BlackAndWhite(frame);
	else ByN= false;
	if (filtro[1])
		sse_invertir(frame);		
	if (filtro[2] && !filtro[7])	
		sse_fotoBinaria(frame);	
	//else filtroRojo = false;
	if (filtro[3])
		sse_zoom(frame);
	if (filtro[4])
		sse_filtroGauseano(frame, ByN);
	if (filtro[5])
		sse_bordesSimples(frame);
	if (filtro[6])
		sse_bordesSobel(frame);
	if (filtro[7])		
		sse_bordesCanny(frame, ByN, filtro[2]);
	if (filtro[8])
		sse_todasJuntas(frame);


    if (filtro[10])
        sse_zoomBillinear(frame);
    if (filtro[11])
        sse_duplicarContraste(frame);
    if (filtro[12])
        sse_colorBalance(frame,RED,GREEN,BLUE);
    
    if (filtro[13])
        sse_bokeh(frame,bokehSize);
    if (filtro[14])
        sse_nearestRot(frame,alpha);
    /*if (filtro[15])
        sse_billinearRot(frame,alpha);
        */
        
}



// Parametros
void mostrarHelp()
{
	cout<<endl<<endl<<"Ayuda:"<<endl<<endl;
	
	cout<<"\t * -f seguido del nombre, sin espacios, de un archivo *.avi que se quiera reproducir"<<endl;
	cout<<"\t\ten caso de no especificar nombre, intetara abrir el archivo default.avi"<<endl;

	cout<<"\t * -c para abrir la camara y usarla en vez de un video"<<endl;


	cout<<"\t * -h para mostrar ayuda"<<endl;
	cout<<"\t * -hc para mostrar los comandos que se pueden usar minstras se ejecuta el programa"<<endl;
    cout<<"\t * -rgb seguido de tres valores, para indicar los valores a utilizar para color-balance"<<endl;
	cout<<endl<<endl;
	cout<<"aprete una tecla para terminar"<<endl<<endl<<endl;
	getchar();
}
void mostrarComandos()
{
	cout<<"Comandos:"<<endl<<endl;
	
	cout<<"\t * 1 al 9 para encender o apagar filtros"<<endl;
	cout<<"\t\t (1) pasar a escala de grises"<<endl;
	cout<<"\t\t (2) invertir colores"<<endl;	
	cout<<"\t\t (3) Thresholding (filtro binario)"<<endl;
	cout<<"\t\t (4) zoom (nearest neighbour)"<<endl;
	cout<<"\t\t (5) suavizado la imagen con  un filtro gaussiano"<<endl;
	cout<<"\t\t (6) Deteccin de bordes rapidamente"<<endl;
	cout<<"\t\t (7) Deteccin de bordes mediante el algoritmo de Sobel"<<endl;
	cout<<"\t\t (8) Deteccin de bordes mediante el algoritmo de Canny"<<endl;
	cout<<"\t\t (9) Todos los filtros juntos"<<endl;

    cout<<"\t\t (Q) zoom (billinear interpolation)"<<endl;
    cout<<"\t\t (W) realce de contraste"<<endl;
    cout<<"\t\t (E) color balance"<<endl;
    cout<<"\t\t (R) bokeh"<<endl;
    cout<<"\t\t (T) rotacion (nearest neighbour)"<<endl;
    //cout<<"\t\t (Y) rotacion (billinear interpolation)"<<endl;

    cout<<"\t\t (O) Disminuye el bokeh"<<endl;
    cout<<"\t\t (P) Aumenta el bokeh"<<endl;

	cout<<endl<<endl;
	cout<<"\t * Cambiar el tipo de codigo:"<<endl;
	cout<<"\t\t (N) Ejecucion normal (CPU, codigo en C++)"<<endl;
	cout<<"\t\t (A) Ejecucion con Assembler (CPU, codigo hecho en Assembler) (pendiente)"<<endl;
	cout<<"\t\t (S) Ejecucion con SSE (CPU, codigo Optimizado con SSE) (pendiente)"<<endl;
	cout<<"\t\t (C) Ejecucion fon CUDA (GPU, codigo en C++/CUDA) (pendiente)"<<endl;
	cout<<endl<<endl;
	cout<<"\t * Aumentar o disminuir la velocidad del video:"<<endl;
	cout<<"\t\t (+) Acelera la aparicion de cada frame del video 1ms"<<endl;
	cout<<"\t\t (-) retrasa la aparicion de cada frame del video 1ms"<<endl;
	cout<<endl<<endl;
	cout<<"\t * Otros:"<<endl;
	cout<<"\t\t (Esc) para salir de la reproduccion"<<endl;
	cout<<"\t\t (Enter) guarda el frame original y el frame luego de que es pasado por los filtro en un *.jpg"<<endl;
	cout<<endl<<endl;
	cout<<"aprete una tecla para terminar"<<endl<<endl<<endl;
	getchar();

}
void parciarParametros(int argc, char *arg[], char* video, bool *camara)
{
	stringstream strStream;
	forn(i,argc)
		if (i != 0)
			strStream<<arg[i]<<" ";
	string ss;
	while(strStream>>ss)
	{
		if (ss == "-c")
		{
			*camara = true;	
			continue;
		}
		if (ss == "-f")
		{
			string a;
			if (!(strStream >> a))
			{
				perror("Los parametros NO tienen un formato valido, colocar -help para ver la ayuda");
				exit(1);
			}	
			if (a.size() > 24)
			{
				perror("el nombre del archivo no puede ser mas grande de 25 caracters");
				exit(1);
			}
			int i = 0;
			while(i < (int)a.size() && i < 24)
			{
				video[i] = a[i];
				video[++i] = '\0';
			}

			continue;
		}
		
        if (ss == "-rgb")
		{
			unsigned col[3];
            forn(i,3)
			if (!(strStream >> col[i]))
			{
				perror("Los parametros NO tienen un formato valido, colocar -help para ver la ayuda");
				exit(1);
			}
			RED = col[2];
            GREEN = col[1];
            BLUE = col[0];

			continue;
		}
        
		if (ss == "-h" || ss == "-help")
		{
			mostrarHelp();
			exit(1);
			break;
		}
		if (ss == "-hc")
		{
			mostrarComandos();
			exit(1);
			break;
		}
		
		perror("Los parametros NO tienen un formato valido, colocar -help para ver la ayuda");
		exit(1);
	}
}/**/
